`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    00:43:39 03/24/2016 
// Design Name: 
// Module Name:    fsm 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
`define STAT_DEF 1'b0
`define STAT_COUNT 1'b1
`define STAT_PAUSE 1'b0
`define ENABLED 1
`define DISABLED 0
module fsm(
   count_enable, // if counter is enabled 
	in, //input control
	clk, // global clock signal
	rst_n // low active reset
	);
	
	// outputs
	output count_enable; // if counter is enabled 
	
	// inputs
	input clk; // global clock signal
	input rst_n; // low active reset
	input in; //input control
	
	reg count_enable; // if counter is enabled 
	reg state; // state of FSM
	reg next_state; // next state of FSM
	
	// FSM state decision
	always @*
		case (state)
		`STAT_DEF:
			if (in)
				begin
				next_state = `STAT_COUNT;
				count_enable = `ENABLED;
				end
			else
				begin
				next_state = `STAT_DEF;
				count_enable = `DISABLED;
				end
		`STAT_COUNT:
			if (in)
				begin
				next_state = `STAT_PAUSE;
				count_enable = `DISABLED;
				end
			else
				begin
				next_state = `STAT_COUNT;
				count_enable = `ENABLED;
				end
		`STAT_PAUSE:
			if (in)
				begin
				next_state = `STAT_COUNT;
				count_enable = `ENABLED;
				end
			else
				begin
				next_state = `STAT_PAUSE;
				count_enable = `DISABLED;
				end
		default:
			begin
			next_state = `STAT_DEF;
			count_enable = `DISABLED;
			end
		endcase
		
	// FSM state transition
	always @(posedge clk or negedge rst_n)
		if (~rst_n)
			state <= `STAT_DEF;
		else
			state <= next_state;


endmodule
